# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2012-06-30.      #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generator git on tinkerforge.com                   #
#############################################################

module Tinkerforge
  # Device for controlling a piezo buzzer
  class BrickletPiezoBuzzer < Device

    # This callback is triggered if a beep set by BrickletPiezoBuzzer#beep is finished
    CALLBACK_BEEP_FINISHED = 3

    # This callback is triggered if the playback of the morse code set by
    # BrickletPiezoBuzzer#morse_code is finished.
    CALLBACK_MORSE_CODE_FINISHED = 4

    FUNCTION_BEEP = 1 # :nodoc:
    FUNCTION_MORSE_CODE = 2 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt>. This object can
    # then be added to the IP connection.
    def initialize(uid)
      super uid

      @expected_name = 'Piezo Buzzer Bricklet'

      @binding_version = [1, 0, 0]

      @callback_formats[CALLBACK_BEEP_FINISHED] = ''
      @callback_formats[CALLBACK_MORSE_CODE_FINISHED] = ''
    end

    # Beeps with the duration in ms. For example: If you set a value of 1000,
    # the piezo buzzer will beep for one second.
    def beep(duration)
      send_request(FUNCTION_BEEP, [duration], 'L', 0, '')
    end

    # Sets morse code that will be played by the piezo buzzer. The morse code
    # is given as a string consisting of "." (dot), "-" (minus) and " " (space)
    # for *dits*, *dahs* and *pauses*. Every other character is ignored.
    # 
    # For example: If you set the string "...---...", the piezo buzzer will beep
    # nine times with the durations "short short short long long long short 
    # short short".
    # 
    # The maximum string size is 60.
    def morse_code(morse)
      send_request(FUNCTION_MORSE_CODE, [morse], 'Z60', 0, '')
    end

    # Registers a callback with ID <tt>cb</tt> to the block <tt>block</tt>.
    def register_callback(cb, &block)
      callback = block
      @registered_callbacks[cb] = callback
    end
  end
end
